<?php
namespace Ebourgogne\Ebourgognetf\Controller;


/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * UserController
 */
class UserController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{

    /**
     * myObjectRepository
     *
     * @var Ebourgogne\Ebourgognetf\Domain\Repository\UserRepository
     * @inject
     */
    protected $userRepository;
    
    /**
     * @var \TYPO3\CMS\Extbase\Persistence\PersistenceManagerInterface
     * @inject
     */
    protected $persistenceManager;


    /**
    * @var string
    */
    protected $baseUrl ='https://monservicepublic.e-bourgogne.fr/api/teleformulaires/';

    /**
    *@var string
    */
    protected $frontBaseUrl = 'https://mesdemarches.e-bourgogne.fr';

    /**
     * action show
     *
     * @param \Ebourgogne\Ebourgognetf\Domain\Model\User $user
     * @return void
     */
    public function showAction()
    {
        /////////////// 
        $tabObjs = $this->userRepository->findAll();
        $tmpObj = $tabObjs[0];
        $apikey = $tmpObj->getApikeyset();
        list($organism) = explode(":", base64_decode($apikey));
        ///////////////
        
        $headers = array(
            "ebou-api-key" . ': ' . $apikey
        );

        $curl = curl_init();
        curl_setopt( $curl, CURLOPT_URL, $this->baseUrl.'search?organismId='.$organism );
        curl_setopt( $curl, CURLOPT_RETURNTRANSFER, true );
        curl_setopt( $curl, CURLOPT_HTTPHEADER, $headers );
        curl_setopt(
            $curl,
            CURLOPT_PROXY,
            $GLOBALS['TYPO3_CONF_VARS']['HTTP']['proxy_host'] . ":" . $GLOBALS['TYPO3_CONF_VARS']['HTTP']['proxy_port']
        );

        $file  = curl_exec( $curl );

        curl_close( $curl );

        $tabObj = json_decode($file);
        

        if($this->settings['confirmation']['showallforms']== true)
        {
            $this->view->assign('conf', 'pas bon');
            for ($i =0; $i < count($tabObj); $i++) {
                $tabObj[$i]->url = $this->frontBaseUrl.$tabObj[$i]->url;
            }
            $this->view->assign('form', $tabObj);
        }
        else
        {

            $options = ($this->settings['listteleforms'] ? \TYPO3\CMS\Core\Utility\GeneralUtility::trimExplode(',', $this->settings['listteleforms']) : array());

            $j=0;   
            for($i = 0; $i < count($tabObj); $i++){
                if(in_array($tabObj[$i]->id, $options)){    
                    $tabObj[$i]->url = $this->frontBaseUrl.$tabObj[$i]->url;
                    $configList[$j]= $tabObj[$i];   
                    $j++;
                }
            }
            $this->view->assign('form', $configList);   
            
        }
    }
    
    /**
     * action apiset
     *
     * @return void
     */
    public function apisetAction(\Ebourgogne\Ebourgognetf\Domain\Model\User $user = NULL)
    {
        $tabObjs = $this->userRepository->findAll();

        $adresseimg = '../typo3conf/ext/ebourgognetf/Resources/Public/Icons/logo-big.png';
        $this->view->assign('img', $adresseimg);

        if(count($tabObjs)>1){
            $this->userRepository->removeAll();
            $this->persistenceManager->persistAll();
        }else{
            $tmpObj = $tabObjs[0];
        }

        if(!empty($user)){
            $apikey = $user->getApikeyset();
            //CHECK SI APIKEY VALIDE

           $headers = array(
                "ebou-api-key" . ': ' . $apikey
            );

            $curl = curl_init();
            curl_setopt( $curl, CURLOPT_URL, $this->baseUrl.'check' );
            curl_setopt( $curl, CURLOPT_RETURNTRANSFER, true );
            curl_setopt( $curl, CURLOPT_HTTPHEADER, $headers );
            curl_setopt(
                $curl,
                CURLOPT_PROXY,
                $GLOBALS['TYPO3_CONF_VARS']['HTTP']['proxy_host'] . ":" . $GLOBALS['TYPO3_CONF_VARS']['HTTP']['proxy_port']
            );

            $file  = curl_exec( $curl );
            curl_close( $curl );

            if($file == 'OK'){
                //On teste si l'objet n'existe pas en base
                if(empty($tmpObj)){
                    $this->userRepository->add($user);
                    $this->persistenceManager->persistAll();
                }
                //Si l'objet n'est pas vide
                else {
                    //On update l'objet
                    $tmpObj->setApikeyset($user->getApikeyset());
                    $this->userRepository->update($tmpObj); 
                    $this->persistenceManager->persistAll();                
                }
                $this->view->assign('message', 'Votre clé a bien été mise à jour.');
                $this->view->assign('apikey', $user->getApikeyset());
                $this->view->assign('gliphi',' glyphicon-ok');
                $this->view->assign('style','color:green;');
            }
            else{
                $this->view->assign('gliphi',' glyphicon-remove');
                if(empty($tmpObj)){
                    $this->view->assign('apikey','');
                }else $this->view->assign('apikey', $tmpObj->getApikeyset());
                $this->view->assign('message', 'Il y a eu une erreur dans la vérification de votre clé.');
                $this->view->assign('style','color:red;');
            }
        }else {
            if(empty($tmpObj))
            {
                $this->view->assign('message', 'Entrez votre clé ci-dessous.');
                $this->view->assign('gliphi',' glyphicon-remove');
            }
             else{ 
                $this->view->assign('message', 'Vous pouvez éditer votre clé ici.');
                $this->view->assign('gliphi',' glyphicon-ok');
                $this->view->assign('apikey', $tmpObj->getApikeyset());
            }
        }

    }

}